
function RK_DBDictionary ()
{
    RK_SimpleDictionary.call(this);
    
    this._init = function (location, name)
    {        
        var dbFile = location.clone();
        dbFile.append(name+'.sqlite');
        
        var exists = dbFile.exists();
        
        this._dbConn = Components.classes["@mozilla.org/storage/service;1"]
                        .getService(Components.interfaces.mozIStorageService)
                        .openDatabase(dbFile);
                        
        if (!exists){
            try {
                this._initDB();
            } catch (e){
                if (dbFile.exists())
                    dbFile.remove();
                throw e;
            }
        }
        
        this._getStatement = this._dbConn.createStatement("SELECT value FROM dict WHERE key = ?1");
    };
    
    this.getValue = function (key)
    {
        const gs = this._getStatement;
        gs.bindUTF8StringParameter(0, key);
        var value = gs.executeStep()? gs.getUTF8String(0) : null;
        gs.reset();
        return value;
    };
    
    
    this.withTransaction = function (thisArg, func)
    {
        var n = arguments.length - 2;
        var a = new Array(n);
        for (var i = 0; i < n; ++i)
            a[i] = arguments[i+2];
        this._dbConn.beginTransactionAs(this._dbConn.TRANSACTION_DEFERRED);
        try{
            func.apply(thisArg, a);
        }finally{
           this._dbConn.commitTransaction();
        }
    };
    
    this._initDB = function ()
    {
        var dict = this._loadDictFromFile();
        
        const db = this._dbConn;
        db.beginTransactionAs(db.TRANSACTION_DEFERRED);
        try {
            db.executeSimpleSQL("CREATE TABLE dict(key TEXT UNIQUE, value TEXT)");
            
            var is = db.createStatement("INSERT INTO dict values(?1, ?2)");
            
            for (var key in dict){
                is.bindUTF8StringParameter(0, key);
                is.bindUTF8StringParameter(1, dict[key]);
                is.execute();
            }
        }finally{
            db.commitTransaction();
        }
    };   
}

