﻿window.addEventListener("load", function (){EnTaTip.init();}, false);
window.addEventListener("close", function (){EnTaTip.close();}, false);


var EnTaTip = {

    enabled : false,
    enabled_hovered : false,
    enabled_selection: false,
    enabled_audio: false,
    X : null,
    Y : null,
    targetDoc : null,
    string : null,
    delay : 1000,
    short_delay : 400,
    timeoutID : null,
    
    originalTarget: null,
    
    audioRequests: {},
    
    mode : 0,
    
    DICTS : {},
    
    CUTENDS : null,
    
    DIRLIST : [],
    
    enabled_dir : {},
    
    ID : '{8efce260-6533-a680-6271-c1a1f9e0e6e4}',
    
    tipOverWord : false,
    
    styleOptions : {},
    
    
    //RE_CHAR : /[abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\u200D]/,
    RE_CHAR : 
/[abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZஅஆஇஈஉஊஎஏஐஒஓஔகஙசஞடணதநபமயரலவழளறன\u200D\u0dca\u0dcf\u0dd0\u0dd1\u0dd2\u0dd3\u0dd4\u0dd6\u0dd8\u0dd9\u0dda\u0ddb\u0ddc\u0ddd\u0dde\u0ddf\u0df2\u0df3\u0df4]/,

    
    leftWordBound:
    function leftWordBound(string, pos)
    {
        var re = this.RE_CHAR;
        while (pos > 0 && re.test(string.charAt(pos-1))) --pos;
        return pos;
    },

    rightWordBound:
    function rightWordBound(string, pos)
    {
        var n = string.length, re = this.RE_CHAR;
        while (pos < n && re.test(string.charAt(pos))) ++pos;
        return pos;
    },
    
    getWordAt:
    function getWordAt(string, offset)
    {
        var a = this.leftWordBound(string, offset);
        var b = this.rightWordBound(string, offset);
        return string.substring(a, b);
    },   
    
    getExtensionVersion:
    function getExtensionVersion(id)
    {
        if (!id) id = this.ID;
    	var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
    	var ext = null;
    	if (em.getItemForID){
    		ext = em.getItemForID(id);
    	}else{
    		ext = em.getItemList(id, null, {})[0];
    	}
    	return ext.version;
    },
    
    getAppVersion:
    function getAppVersion()
    {
        return Components.classes["@mozilla.org/xre/app-info;1"]
                .getService(Components.interfaces.nsIXULAppInfo)
                .version;
    },
    
    
    getExtensionFolder:
    function getExtensionFolder(id)
    {
        if (!id) id = this.ID;
        return Components.classes["@mozilla.org/extensions/manager;1"]
               .getService(Components.interfaces.nsIExtensionManager)
               .getInstallLocation(id)
               .getItemLocation(id);
    },
    
    
    
    loadDict:
    function loadDict(direction)
    {
        if (this.com[direction]) return true;
    
        try
        {
            var dict = new this.DictClass();
            dict.init(this.getExtensionFolder(), direction);
            this.com[direction] = dict;
        }
        catch (ee)
        {
            alert('Error on loading "'+direction+'" dictionary!\n\n'+ee);
            throw ee;
            return false;
        }
        
        return true;
    },
    
      
    
    
    
    
    
    init:
    function init()
    {    
        var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
                                     .getService(Components.interfaces.nsIAppShellService)
                                     .hiddenDOMWindow;
                                     
        if (!hiddenWindow.EnTaTipCommon){hiddenWindow.EnTaTipCommon = {};}
        this.com = hiddenWindow.EnTaTipCommon;
        
        this.DictClass = (this.getAppVersion().charAt(0) > '1') ? RK_DBDictionary : RK_SimpleDictionary;
//         this.DictClass = RK_SimpleDictionary;

        this.mouseMoveListener = function(e){EnTaTip.onMouseMove(e);};
        this.mouseUp2Listener  = function(e){EnTaTip.onMouseUp2(e);};
        this.mouseUpListener   = function(e){EnTaTip.onMouseUp(e);};
        this.keyUpListener     = function(e){EnTaTip.onKeyUp(e);};
    
        this.pref = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefService)
                        .getBranch("extensions.EnTaTip.");
        this.pref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
        
        this.syncPrefs(true);
        
        this.pref.addObserver("", this, false);
    },
    
    getPref:
    function getPref (name)
    {
        var b = this.pref;
        switch (b.getPrefType(name)){
            case b.PREF_STRING: return b.getCharPref(name);
            case b.PREF_INT: return b.getIntPref(name);
            case b.PREF_BOOL: return b.getBoolPref(name);
            default: return null;
        }
    },
    
    
    observe:
    function observe(aSubject, aTopic, aData)
    {
        if (aTopic != "nsPref:changed") return;
        if (aData == 'enabled_dir')
            this.updateDirections();
        else if (aData.startswith('style.'))
            this.updateStyle(aData);
        else if (!aData.startswith('options.'))
            this.syncPrefs();
    },
    
    
    close:
    function close(event)
    {
        this.pref.removeObserver("", this);
    },
    
    
    createTip:
    function createTip(doc)
    {
        var node = doc.createElement('div');    
        node.id = 'EnTaTipToolTip';
        node.className = 'EnTaTipToolTip';
        node.style.position = 'absolute !important';
        node.style.left = '0';
        node.style.top = '0';
        node.style.height = 'auto !important';
        node.style.width = 'auto !important';
        node.style.zIndex = '65535 !important';
        node.style.fontStyle = 'normal !important'
        node.style.fontWeight = 'normal !important'
        node.style.lineHeight = '130% !important'
        node.style.margin = '0 !important';
        node.style.padding = '3px !important';
        node.style.letterSpacing = 'normal !important';
        node.style.textAlign = 'left !important';
        node.style.textDecoration = 'none !important';
        node.style.textIndent = '0 !important';
        node.style.textShadow = 'none !important';
        node.style.textTransform = 'none !important';
        node.style.whiteSpace = 'normal !important';
        node.style.wordSpacing = 'normal !important';
        node.style.overflow = 'visible !important';
        node.style.border = '1px solid !important';
        node.style.display = 'block !important'
        node.style.visibility = 'hidden !important';
        this.applyStyle(node, this.styleOptions);
        node.addEventListener("mousedown", this.abortEvent, true);
        return node;
    },
    
    
    createStyle:
    function createStyle(doc) {
        var node = doc.createElement('style');
        node.id = 'EnTaTipGlobalStyle';
        node.innerHTML =
        this.CSSImportantRule('.EnTaTipToolTip *', {
                                    'background': 'inherit',
                                    'font-family': 'inherit',
                                    'font-size': 'inherit',
                                    'font-size-adjust': 'normal',
                                    'font-stretch': 'normal',
                                    'lineHeight': 'inherit',
                                    'font-variant': 'normal',
                                    'border': '0px',
                                    'text-transform': 'inherit',
                                    'color': 'inherit',
                                    'font-style': 'inherit',
                                    'text-decoration': 'inherit',
                                    'margin': '0px 0px 0px 0px',
                                    'padding': '0px 0px 0px 0px',
                                    'float': 'none',
                                    'display': 'inline',
                                    'cursor': 'default'
                                    })
        + this.CSSImportantRule('.EnTaTipReplacer', {
                                    'cursor': 'pointer'
                                    })
        + this.CSSImportantRule('.EnTaTipToolTip hr', {
                                    'margin': '0.4em 0',
                                    'display': 'block',
                                    'border': '1px inset'
                                    })
        + this.CSSImportantRule('.EnTaTipTranslation', {
                                    'font-style': (this.styleOptions._italic ? 'italic' : 'normal')
                                    })
        + this.CSSImportantRule('.EnTaTipTranslation a', {
                                    'color': this.styleOptions._color2,
                                    'font-style': (this.styleOptions._italic2 ? 'italic' : 'normal'),
                                    'text-decoration': (this.styleOptions._underline2 ? 'underline' : 'none')
                                    })
        + this.CSSImportantRule('.EnTaTipTranslation a:hover', {
                                    'color': this.styleOptions._color3,
                                    'text-decoration': (this.styleOptions._underline3 ? 'underline' : 'none')
                                    });
        return node;
    },
    
    CSSImportantRule:
    function CSSImportantRule(selector, d)
    {
        var css = selector + ' {';
        for (var k in d)
            css += k+': '+d[k]+' !important;  ';
        return css + '}\n'
    },


    insertStyle:
    function insertStyle(doc)
    {
        var style = doc.getElementById('EnTaTipGlobalStyle');
        if (!style) {
            style = (this._style && doc === this._styleDoc)? this._style : this.createStyle(doc);
            doc.getElementsByTagName('head')[0].appendChild(style);
        }
        this._style = style;
        this._styleDoc = doc;
        return style;
    },    
    
    
    insertTip:
    function insertTip(doc)
    {
        this.insertStyle(doc);
        
        var tip = doc.getElementById('EnTaTipToolTip');
        if (!tip) {
            tip = (this._tip && doc === this._tipDoc)? this._tip : this.createTip(doc);
            doc.body.appendChild(tip);
        }else{
            this.hideNode(tip);
        }
        this._tip = tip;
        this._tipDoc = doc;
        return tip;
    },
    
    
    removeTip:
    function removeTip()
    {
        if (this._tip && this._tip.parentNode) {
            this._tip.parentNode.removeChild(this._tip);
            this.hideNode(this._tip);
        }
    },
    
    removeStyle:
    function removeStyle()
    {
        if (this._style && this._style.parentNode)
            this._style.parentNode.removeChild(this._style);
    },
    
    
    
    
    processRequest:
    function processRequest(string, selectmode)
    {
        this.timeOut();
        
        if (!string) return false;
        this.string = string;
        
        const me = this;
        const doc = this.targetDoc;
        var def = doc.createElement('span');
        var prevdir, ar = [];
        
        function A (dir, key, value, aprox){
            if (prevdir)
                def.appendChild( doc.createElement( (prevdir == dir)? 'br' : 'hr' ) );
            def.appendChild(me.buildDef(dir, key, value, aprox, selectmode));
            prevdir = dir;
            if (selectmode && dir.substr(0, 2) == 'en')
                ar.push(key);
        }
    
        const maxd = 1;
    
        function _lookupin (dict){
            var def = dict.getValue(string);
            if (def) A(dir, string, def, 0);
            else{
                var numd = 0;
                var lang = dir.substr(0, 2);
                var cuts = this.CUTENDS[lang];
                var adds = this.CUTENDS[lang+'+'];
                var key, key2;
                for each (var cut in cuts){
                    if (string.endswith(cut)){
                        key = string.substr(0, string.length - cut.length);
                        def = dict.getValue(key);
                        if (def){
                            A(dir, key, def, 1);
                            if (++numd >= maxd) break;
                        }
                        for each (var add in adds){
                            key2 = key + add;
                            def = dict.getValue(key2);
                            if (def){
                                A(dir, key2, def, 1);
                                if (++numd >= maxd) break;
                            }
                        }
                    }
                    if (numd >= maxd) break;
                }
            }
        }
    
        function lookupin (dict){
            if ('withTransaction' in dict)
                dict.withTransaction(me, _lookupin, dict);
            else
                _lookupin.call(me, dict);
        }
        
        var string = string.toLowerCase();        
        for each (var dir in this.DIRLIST){
            if (this.com[dir] && this.enabled_dir[dir])
                lookupin(this.com[dir]);
        }
        
        if (def.firstChild){
            this.showDef(def);
            if (selectmode){
                this.passToMode2();
                if (this.enabled_audio){
                    for each (var key in ar){
                        this.audioRequest('en', key);
                    }
                }
            }
            return true;
        }else{
            return false;
        }
    },
    
    
    
    
    buildDef:
    function buildDef(dir, key, value, aprox, selectmode)
    {
        var langs = dir.split('-');
        const doc = this.targetDoc;
        var defnode = this.createElement('span', {class:"EnTaTipTranslation"});
        if (selectmode){
            var invdir = langs[1]+'-'+langs[0];
            var dict = this.com[invdir], t, w, title;
            for each (w in value.split(', ')){
                if (t) defnode.appendChild(doc.createTextNode(', '));
                t = this.createElement('a', {class:"EnTaTipReplacer"}, w);
                if (dict)
                    title = dict.getValue(w.toLowerCase());
                    if (title)
                        t.setAttribute('title', title);
                defnode.appendChild(t);
            }
        }else{
            defnode.appendChild(doc.createTextNode(value));
        }
        return  this.createElement('span', null,
                    //this.createElement('img', {src:"chrome://entatip/skin/"+langs[0]+".gif", title:langs[0]}),
                    (aprox ? ' (' : ' '),
                    this.createElement('span', {id:"EnTaTip_"+langs[0]+"_"+key, class:"EnTaTipReplacer", style:"font-weight:bold"}, (key.length>1)?key[0].toUpperCase()+key.substring(1,key.length):key),
                    (aprox ? ')' : ''),
                    this.createElement('span', {style:"font-weight:bold"}, ': '),
                     this.createElement('br'),                 
                    //this.createElement('img', {src:"chrome://entatip/skin/"+langs[1]+".gif", title:langs[1]}),
                    ' ',
                    defnode
                );
    },
    
    
               
    showNode:
    function showNode(node)
    {
        node.style.visibility = 'visible !important';
    },
    
    hideNode:
    function hideNode(node)
    {
        node.style.visibility = 'hidden !important';
    },
    
    
    showDef:
    function showDef(def)
    {
        var doc = this.targetDoc;
        var block = this.insertTip(doc);
        this.tipOverWord = false;
        if (def){
            while (block.firstChild)
                block.removeChild(block.firstChild);
            block.appendChild(def)
        }
        var scrollLeft = doc.documentElement.scrollLeft + doc.body.scrollLeft;
        var scrollTop = doc.documentElement.scrollTop + doc.body.scrollTop;
        block.style.top = scrollTop+'px !important';
        block.style.left = scrollLeft+'px !important';
        var blockWidth = block.offsetWidth;
        var blockHeight = block.offsetHeight;        
        
        var contentWindow = doc.defaultView;
        
        var viewWidth = contentWindow.innerWidth;
        var viewHight = contentWindow.innerHeight;
        
        if (scrollTop) viewWidth -= 20;
        if (scrollLeft) viewHight -= 20;
        
        if (this._visible && this._tipDoc === doc) {
            this.X = this.pX - scrollLeft;
            this.Y = this.pY - scrollTop;
        }else{
            this.pX = this.X + scrollLeft;
            this.pY = this.Y + scrollTop;
        }
        var left = this.X - 15;
        var top = this.Y + 15;
       
        var dx = left + blockWidth - viewWidth;
        if (dx > 0) left -= dx;
        if (left < 0) left = 0;
    
        if (top + blockHeight + 10 > viewHight){
            top = this.Y - 15 - blockHeight;
            this.tipOverWord = true;
        }
        if (top < 0) top = 0;
    
        left += scrollLeft;
        top += scrollTop;
    
        block.style.top = top + 'px !important';
        block.style.left = left + 'px !important';
        this.showNode(block);
        this._visible = true;
    },
    
    
    
    
    recEvent:
    function recEvent(event)
    {
        this.X = event.clientX;
        this.Y = event.clientY;
        this.originalTarget = event.originalTarget;
        this.explicitOriginalTarget = event.explicitOriginalTarget;
        this.targetDoc = event.originalTarget.ownerDocument;
        this.rangeParent = event.rangeParent;
        this.rangeOffset = event.rangeOffset;
    },
    
    
    
    
    
    onMouseStay:
    function onMouseStay(node, offset)
    {
        EnTaTip.timeOut();
        
        if (!node) return;
        
        var string = node.textContent;
    
        if (string)
        {
            string = EnTaTip.getWordAt(string, offset);
            if (string) EnTaTip.processRequest(string);
        }
    },
    
    
    
    timeOut:
    function timeOut(event)
    {
        if (this.timeoutID)
        {
           window.clearTimeout(this.timeoutID);
           this.timeoutID = null;
        }
    },
    
    
    passToMode1:
    function passToMode1()
    {
        window.removeEventListener("mouseup", this.mouseUp2Listener, true);
        if (this.enabled_selection){
            window.addEventListener("mouseup", this.mouseUpListener, true);
        }else{
            window.removeEventListener("mouseup", this.mouseUpListener, true);
        }
        this.mode = 1;
    },
    
    
    passToMode2:
    function passToMode2()
    {
        window.removeEventListener("mouseup", this.mouseUpListener, true);
        window.addEventListener("mouseup", this.mouseUp2Listener, true);
        this.mode = 2;
    },

    
    
    onMouseMove:
    function onMouseMove(event)
    {
        var explicit = event.shiftKey;
        
        if (!explicit && (this.mode != 1)) return;
        
        this.terminateProcess();
        
        if (!explicit && !this.enabled_hovered) return;
    
        if(!event.ctrlKey && event.originalTarget.ownerDocument instanceof HTMLDocument)
        {
            var node = event.explicitOriginalTarget;
            
            if ('textContent' in node && (explicit || 'data' in node))
            {
                var delay = (explicit)? this.short_delay : this.delay;
                if (delay <= 0) return;
                this.recEvent(event);
                this.timeoutID = window.setTimeout(this.onMouseStay, delay, event.rangeParent, event.rangeOffset);
            }
        }
    },
    
    
    onMouseUp:
    function onMouseUp(event)
    {
        if(event.button != 0 || !(event.originalTarget.ownerDocument instanceof HTMLDocument)) return;
        
        this.terminateProcess();
        
        var node = event.explicitOriginalTarget;
        
        var selected = null;
        
        try {
            selected = node.value.substring(node.selectionStart, node.selectionEnd).strip();
        } catch (e) {
            selected = node.ownerDocument.defaultView.getSelection().toString().strip();
        }
        if (selected && selected.length <= 25)
        {
            this.recEvent(event);
            this.processRequest(selected, true);
        }
    },


    abortEvent:
    function abortEvent(event){
        event.preventDefault();
        event.stopPropagation();
    },
    

    
    onMouseUp2:
    function onMouseUp2(event)
    {
        if(!(event.originalTarget.ownerDocument instanceof HTMLDocument)) return;
        var node = event.originalTarget;
        if (event.button == 0) {
            if (node.getAttribute('class') == 'EnTaTipReplacer') {
                var res = node.textContent;
                node = this.explicitOriginalTarget;
                var ss;
                try{
                    var ss = node.selectionStart;
                }catch (e){}
                if (!(ss === undefined)){
                    var val = node.value;
                    var se = node.selectionEnd;
                    var selected = val.substring(ss, se);
                    res = res.toSameCaseAs(selected.strip());
                    res = selected.replace(/^(\s*).*?(\s*)$/, '$1'+res+'$2');
                    var scrollTop = node.scrollTop;
                    var scrollLeft = node.scrollLeft;
                    node.value = val.substring(0, ss) + res + val.substring(se);
                    node.selectionStart = node.selectionEnd = (ss + res.length);
                    node.focus();
                    node.scrollTop = scrollTop;
                    node.scrollLeft = scrollLeft;
                } else {
                    node = this.rangeParent;
                    var doc = node.ownerDocument;
                    var val = node.textContent;
                    var a = this.leftWordBound(val, this.rangeOffset);
                    var b = this.rightWordBound(val, this.rangeOffset);
                    res = res.toSameCaseAs(val.substring(a, b));
                    val = val.substring(0, a) + res + val.substring(b);
                    this.rangeParent.textContent = val;
                    var sel = doc.defaultView.getSelection();
                    if (sel){
                        sel.collapse(node, a + res.length);
//                         var range = doc.createRange();
//                         range.setStart(node, a);
//                         range.setEnd(node, a + res.length);
//                         sel.removeAllRanges();
//                         sel.addRange(range);
                    }
                    try{
                        node.focus();
                    }catch(e){}
                        
                }
            }
            this.terminateProcess();
        }
        else if (event.button == 1) {
            this.processRequest(node.textContent, true);
        }
    },
    
    
    
    
    onKeyUp:
    function onKeyUp(event)
    {
        if (event.keyCode == 16){
            if (this.mode == 1){
                if (this._visible) this.processRequest(this.string, true);
            }else{
                this.terminateProcess();
            }
        }
//         else if (event.keyCode == 27){
//             this.terminateProcess();
//         }
    },

    
    
    terminateProcess:
    function terminateProcess()
    {
        this.timeOut();
        if (this._visible){
            this.removeTip();
            this.removeStyle();
            this._visible = false;
        }
        if (this.mode != 1){
            this.passToMode1();
        }
        for (var key in this.audioRequests){
            this.audioRequests[key].abort();
            delete this.audioRequests[key];
        }
    },
    
    applyStyle:
    function applyStyle(node, style, value)
    {
        function applyOne(name, value){
            if (name.charAt(0) == '_') return;
            if (typeof(value) == 'number')
                node.style[name] = value + 'px !important';
            else
                node.style[name] = value + ' !important';
        }
        if (value === undefined)
            for (var name in style)
                applyOne(name, style[name]);
        else
            applyOne(style, value);
    },
    
    loadStyleOptions:
    function loadStyleOptions()
    {
        for each (var opt in this.pref.getChildList('style.', {}))
            this.styleOptions[opt.substring(6)] = this.getPref(opt);
    },
    
    updateStyle:
    function updateStyle(prefname)
    {
        var name = prefname.substring(6);
        var value = this.getPref(prefname);
        this.styleOptions[name] = value;
        if (name.charAt(0) == '_') {
            this.removeStyle();
            this._style = null;
            if (this._visible)
                this.insertStyle(this._tipDoc);
        }else{
            if (this._tip) this.applyStyle(this._tip, name, value);
        }
    },        

    
    updateDirections:
    function updateDirections()
    {
        var arr = this.pref.getCharPref('enabled_dir');
        var i = 0;
        for each (var dir in this.DIRLIST){
            var checked = this.enabled_dir[dir] = (arr[i++] * 1) && this.loadDict(dir);
            window.document.getElementById('entatip-direction-'+dir).setAttribute("checked", (checked)? "true" : "false");
        }
    },
    
    generateDirections:
    function generateDirections()
    {
        var popup = window.document.getElementById('entatip-popup');
        var sep = popup.getElementsByAttribute('id', 'entatip-after_dict_list')[0];
        for each (var dir in this.DIRLIST){
            var item = window.document.createElement("menuitem");
            item.setAttribute('type', 'checkbox');
            item.setAttribute('id', 'entatip-direction-'+dir);
            item.setAttribute('label', dir.replace('-', ' --> '));
            item.setAttribute('oncommand', 'EnTaTip.toggleDirection("'+dir+'");');
            popup.insertBefore(item, sep);
        }
    },
            
    
    syncPrefs:
    function syncPrefs(all)
    {
        if (all){
            this.DIRLIST = this.pref.getCharPref('dirlist').split('|');
            eval('this.CUTENDS = ' + this.pref.getCharPref('cutends'));
            this.generateDirections();
            this.updateDirections();
            this.loadStyleOptions();
        }
        
        this.enabled = this.pref.getBoolPref('enabled');
        this.enabled_selection = this.pref.getBoolPref('enabled_selection');
        
        this.passToMode1();
        this.terminateProcess();
        
        if (this.enabled) {
            window.addEventListener("mousemove", this.mouseMoveListener, true);
            window.addEventListener("keyup", this.keyUpListener, true);
        }else{
            window.removeEventListener("mousemove", this.mouseMoveListener, true);
            window.removeEventListener("keyup", this.keyUpListener, true);
            window.removeEventListener("mouseup", this.mouseUpListener, true);
        }
    
        this.enabled_audio = this.pref.getBoolPref('enabled_audio');
        this.enabled_hovered = this.pref.getBoolPref('enabled_hovered');
        this.delay = this.pref.getIntPref('delay');
        this.short_delay = this.pref.getIntPref('short_delay');
    
        window.document.getElementById('entatip-enabled_hovered').setAttribute("checked", this.enabled_hovered);
        window.document.getElementById('entatip-enabled_selection').setAttribute("checked", this.enabled_selection);
        window.document.getElementById('entatip-enabled_audio').setAttribute("checked", this.enabled_audio);
        window.document.getElementById('entatip-enabled').setAttribute("checked", this.enabled);
        window.document.getElementById('entatip-icon').setAttribute("state", (this.enabled? "on" : "off"));
    },
    
    
    showOptions:
    function showOptions()
    {
        var paneID = (this._visible)? 'Style' : 'Main';
        var features = 'chrome,titlebar,toolbar,centerscreen';
        if (this.pref.getBoolPref('options.modal')) features += ',modal';
        if (this.pref.getBoolPref('options.dependent')) features += ',dependent';
        window.openDialog('chrome://entatip/content/options.xul', '', features, paneID);
    },
    
    
    setEnableDirections:
    function setEnableDirections()
    {
        var arr = new Array(this.DIRLIST.length);
        var i = 0;
        for each (var dir in this.DIRLIST){
            arr[i++] = !!this.enabled_dir[dir] * 1;
        }
        this.pref.setCharPref('enabled_dir', arr.join(''));
    },
        
    toggleDirection:
    function toggleDirection(dir)
    {
        this.enabled_dir[dir] = !this.enabled_dir[dir];
        this.setEnableDirections();
    },
    
    toggleOption:
    function toggleOption(optname)
    {
        this.pref.setBoolPref(optname, !this[optname]);
    },

    
    
    onStatusMouseDown:
    function onStatusMouseDown(event)
    {
        if (event.button == 0)
            this.toggleOption('enabled');
        else if (event.button == 1)
            this.showOptions();
    },
    
    
    createElement:
    function createElement(name, attributes)
    {
        const doc = this.targetDoc
        var node = doc.createElement(name);
        if (attributes)
            for (var attrname in attributes)
                node.setAttribute(attrname, attributes[attrname]);
        for (var i = 2; i < arguments.length; ++i){
            var t = arguments[i];
            if (typeof(t) == 'string')
                t = doc.createTextNode(t);
            node.appendChild(t);
        }
        return node;
    },
    
    audioRequest:
    function audioRequest(lang, word)
    {
        var key = "EnTaTip_"+lang+"_"+word;
        var me = this;
        var doc = this.targetDoc;
        var request;
        
        function onload(event)
        {
            var xml = request.responseXML;
            var audio = null;
            try {audio = xml.getElementsByTagName('audio')[0].firstChild.data;}
            catch (ee) {return;}
            if (!audio) return;
            var pron = '';
            try {pron = xml.getElementsByTagName('pron')[0].firstChild.data;}
            catch (ee) {}
            var node = doc.getElementById(key);
            if (!node) return;
            node.appendChild(me.createElement('span', {onmouseover:"this.firstChild.DoPlay();",
                                                       onmouseout:"this.firstChild.DoStop();"},
                                me.createElement('embed', {hidden:true,
                                                           type:"audio/x-pn-realaudio-plugin", showControls:1,
                                                           width:280, height:256,
                                                           src: audio}),
                                me.createElement('img', {src:"chrome://entatip/skin/audio.gif", title: pron})
                             ));
            if (me.tipOverWord) me.showDef();
        }
        
        if (key in this.audioRequests) {
            request = this.audioRequests[key];
            if (request.status == 200) onload();
            return request;
        }
            
        request = new XMLHttpRequest();
        this.audioRequests[key] = request;
        request.onload = onload;
        request.open("GET", 'http://dict.cn/ws.php?utf8=true&q=' + word, true);
        request.send(null);
        return request;    
    }
};



String.prototype.toCapitalCase = function()
{
    return this[0].toUpperCase() + this.substring(1).toLowerCase();
};

String.prototype.toSameCaseAs = function(s)
{
    if (s == s.toLowerCase()) return this.toLowerCase();
    if (s == s.toCapitalCase()) return this.toCapitalCase();
    if (s == s.toUpperCase()) return this.toUpperCase();
    return this.substring(0);
};

String.prototype.strip = function()
{
    return this.replace(/^\s*(.*?)\s*$/, '$1');
};

String.prototype.endswith = function(end)
{
    return this.substr(end.length *(-1)) == end;
};

String.prototype.startswith = function(str)
{
    return this.indexOf(str) == 0;
};
